(* $Id: wtool_types.ml 1167 2012-12-28 22:13:41Z gerd $ *)

type 'a result =
  [ `Ok of 'a
  | `Timeout
  | `Error of string
  ]


class type wtool_handler =
object
  method base_url : string
  method list : string -> string list result
  method get : Godi_file.tmpdir -> string list -> Godi_file.filename result list
  method put : Godi_file.filename -> string -> unit result
  method api : (string * string) list -> int result
end


class type wtool_factory =
object
  method configure_timeout : float -> unit
  method configure_user : string -> unit
  method configure_store_passwords : bool -> unit
  method configure_localbase : string -> unit
  method open_location : string -> wtool_handler
  method url_help : string list
  method have_auth : bool
end
